#!/usr/bin/env pugs

=begin Problem
Consider all integer combinations of a^b for 2 <= a <= 5 and 2 <= b <= 5:

2^2=4, 2^3=8, 2^4=16, 2^5=32
3^2=9, 3^3=27, 3^4=81, 3^5=243
4^2=16, 4^3=64, 4^4=256, 4^5=1024
5^2=25, 5^3=125, 5^4=625, 5^5=3125
If they are then placed in numerical order, with any repeats removed, we get the following sequence of 15 distinct terms:

4, 8, 9, 16, 25, 27, 32, 64, 81, 125, 243, 256, 625, 1024, 3125

How many distinct terms are in the sequence generated by a^b for 2 <= a <= 100 and 2 <= b <= 100?
=cut

use v6;
use Benchmark;

sub uniqterms($a, $b) {
    my KeySet %seen;

    # this feels like it should be do-able in one for, but I can't figure it out
    for 2..$a -> $base {
        for 2..$b -> $exp {
            %seen{$base ** $exp} = 1;
        }
    }

    +%seen.keys;
}

sub check {
    my $terms = uniqterms(5, 5);
    say $terms == 15 ?? "ok" !! "not ok: got $terms, expected 15";
}

sub main {
    say uniqterms(100, 100);
}

my @t = timeit(1, \&main);
say "execution time: @t[0]";
